// Mem bug examples
// complex use after free in library
//
// Klaus Kusche, 2014

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>

#define ELEMS 1000
#define ITERS 10000
#define MAXSIZE 1000

int main(void)
{
  char *a[ELEMS];
  int i;
  char *p;

  srand(time(NULL));
  
  for (i = 0; i < ELEMS; ++i) {
    a[i] = NULL;
  }

  for (i = 0; i < ITERS; ++i) {
    int n = rand() % ELEMS;
    if (a[n] == NULL) {
      a[n] = (char *) (malloc(rand() % MAXSIZE));
    } else {
      free(a[n]);
      a[n] = NULL;
    }
  }

  p = (char *) (malloc(rand() % MAXSIZE + 10));
  strcpy(p, "Hallo");

  for (i = 0; i < ITERS; ++i) {
    int n = rand() % ELEMS;
    if (a[n] == NULL) {
      a[n] = (char *) (malloc(rand() % MAXSIZE));
    } else {
      free(a[n]);
      a[n] = NULL;
    }
  }

  free(p);

  for (i = 0; i < ITERS; ++i) {
    int n = rand() % ELEMS;
    if (a[n] == NULL) {
      a[n] = (char *) (malloc(rand() % MAXSIZE));
    } else {
      free(a[n]);
      a[n] = NULL;
    }
  }

  printf("Ausgabe eines freigegebenen Strings: %s\n", p);
  
  for (i = 0; i < ITERS; ++i) {
    int n = rand() % ELEMS;
    if (a[n] == NULL) {
      a[n] = (char *) (malloc(rand() % MAXSIZE));
    } else {
      free(a[n]);
      a[n] = NULL;
    }
  }

  printf("So weit drfte er erst recht nicht kommen...\n");
  
  return 0;
}
